#include <unknwn.h>
#include <stdio.h>

#include "jtvrem.h"
#include "jtvremsk.h"

typedef bool (WINAPI * T2CSWStart)    (void);
typedef bool (WINAPI * T2CSWStop)     (void);
typedef bool (WINAPI * T2CSWWrite)    (DWORD value);
typedef bool (WINAPI * T2CSWRead)     (DWORD * value);
typedef bool (WINAPI * T2CSWSendACK)  (void);
typedef bool (WINAPI * T2CSWSendNACK) (void);
typedef bool (WINAPI * T2CInitSWMode) (long Freq);
typedef bool (WINAPI * T2CIsInitOK)   (void);
typedef bool (WINAPI * TSetGPData)    (int fromBit,int toBit,DWORD value,int offset);

KeyDef keys[]=
{

        { 0x1c, "Key_Power", "", },  
        { 0x15, "Key_Source", "", }, 
        //None
        { 0x12, "Key_PcVid", "Key_FullScreen", },

        { 0x11, "Key_Still", "Key_Capture", },
        { 0x0f, "Key_Window", "Key_Window", },
        { 0x13, "Key_AirCable", "Key_AirCableTV", },
        { 0x10, "Key_Mute", "Mute", },

        { 0x01, "Key_1", "1", },
        { 0x02, "Key_2", "2", },
        { 0x03, "Key_3", "3", },
        { 0x1A, "Key_VolumeUp", "VolumeUp", },

        { 0x04, "Key_4", "4", },
        { 0x05, "Key_5", "5", },
        { 0x06, "Key_6", "6", },
        { 0x1e, "Key_VolumeDown", "VolumeDown", },

        { 0x07, "Key_7", "7", },
        { 0x08, "Key_8", "8", },
        { 0x09, "Key_9", "9", },
        { 0x1B, "Key_ChannelUp", "ChannelUp", },

        { 0x0a, "Key_Loop", "Recall", },
        { 0x00, "Key_0", "0", },
        { 0x17, "Key_Enter", "Enter", },
        { 0x1f, "Key_ChannelDown", "ChannelDown", },

        { 0x0d, "Key_Play", "Play", },
        { 0x0e, "Key_Stop", "Stop", },
        { 0x1d, "Key_Left", "Fast Backwards", },
        { 0x19, "Key_Right", "Fast Forwards", },

        { 0x16, "Key_ADD", "Add", },
        { 0x14, "Key_Func", "Func", },
        { 0x18, "Key_PrevLinear", "-", },
        { 0x0c, "Key_NextLinear", "+", },

};

typedef UINT (CALLBACK* LPFNDLLFUNC1)(DWORD,UINT);


DWORD dwParam1;
UINT  uParam2, uReturnVal;
INT first_delay=500;	// default first delay for a key
INT repeat_delay=300;	// default repeat delay for a key
INT key_pause=500;


void log(const char* str, ...)
{
  va_list arglist;

  FILE* l=fopen("JTVRemote.log","a+t");
  if (l==NULL) return;
  va_start( arglist, str );
  vfprintf(l, str, arglist );
  va_end( arglist );
  fclose(l);

}

class JTVRemote : public CRemoteDriver
{

public:

        JTVRemote(KeyDef *k, int count) : CRemoteDriver(k, count)
		{
			log("********************************************\n");
			log("*Initializing Tekram M205pro remote module.*\n");
            log("*       Dandruff, <t_gl@pisem.net>.        *\n");
			log("********************************************\n");
		};


        void PollingThread()
        {
         first_delay=GetPrivateProfileInt("JTVRemote","KeyFirstDelay",first_delay,".\\jtv.ini");
         repeat_delay=GetPrivateProfileInt("JTVRemote","KeyRepeatDelay",repeat_delay,".\\jtv.ini");
		 log("KeyFirstDelay=%d, KeyRepeatDelay=%d\n",first_delay,repeat_delay);
		 HINSTANCE dllhandle;
         DWORD cod,last_code=0xFF,cod2;
		 T2CSWStart          I2CSWStart;
		 T2CSWStop           I2CSWStop;
         T2CSWWrite          I2CSWWrite;
	     T2CSWRead           I2CSWRead;
		 T2CSWSendACK        I2CSWSendACK;
         T2CSWSendNACK       I2CSWSendNACK;
	     T2CInitSWMode       I2CInitSWMode;
		 T2CIsInitOK         I2CIsInitOK;
		 TSetGPData          SetGPDataBits;

			 dllhandle = LoadLibrary("Btvid_32.dll");
		     I2CSWStart      =(T2CSWStart)       GetProcAddress(dllhandle,"I2CSWStart");
			 I2CSWStop       =(T2CSWStop)        GetProcAddress(dllhandle,"I2CSWStop");
	         I2CSWWrite      =(T2CSWWrite)       GetProcAddress(dllhandle,"I2CSWWrite");
		     I2CSWRead       =(T2CSWRead)        GetProcAddress(dllhandle,"I2CSWRead");
			 I2CSWSendACK    =(T2CSWSendACK)     GetProcAddress(dllhandle,"I2CSWSendACK");
	         I2CSWSendNACK   =(T2CSWSendNACK)    GetProcAddress(dllhandle,"I2CSWSendNACK");
		     I2CInitSWMode   =(T2CInitSWMode)    GetProcAddress(dllhandle,"I2CInitSWMode");
			 I2CIsInitOK     =(T2CIsInitOK)      GetProcAddress(dllhandle,"I2CIsInitOK");
			 SetGPDataBits	 =(TSetGPData)       GetProcAddress(dllhandle,"SetGPDATABits");

		//Set volume in tekram
   		   log("Set volume Tekram in jtv.ini ->[JTVRemote]->TekVolume 0-15,16-not use\n");
		   int TekVolume=16;
           TekVolume=GetPrivateProfileInt("JTVRemote","TekVolume",TekVolume,".\\jtv.ini");
		   if (TekVolume<16)
		   {
    		 log("Tekram volume is %d\n",TekVolume);
		     TekVolume=15-TekVolume;
		     int VAud=(1<<((TekVolume>>2)&0x03))+(0x80<<(TekVolume&0x3))+0x6000;
  			 for (int i=0;i!=0x12;i++)
			     {
			     SetGPDataBits(1,1,(VAud>>i)&1,0);
			     SetGPDataBits(0,0,1,0);
			     SetGPDataBits(0,0,0,0);
			     }
			   SetGPDataBits(1,1,0,0);
			   SetGPDataBits(2,2,1,0);
			   SetGPDataBits(2,2,0,0);
		   }
        //Set mute in tekram
   		   log("Set mute Tekram in jtv.ini ->[JTVRemote]->TekMute 0-off 1-on 2-not set\n");
		   TekVolume=2;
           TekVolume=GetPrivateProfileInt("JTVRemote","TekMute",TekVolume,".\\jtv.ini");
		   if (TekVolume<2)
		   {
			 SetGPDataBits(3,4,TekVolume,0);
    		 log("Tekram Mute is %d\n",TekVolume);
		   }
		   for (int i=0;i<10;i++)
			{
			 I2CIsInitOK();
	         I2CInitSWMode(20000);                         //default 200kGz but work in 10-300 
			 I2CSWStart()    ; 
	         I2CSWWrite(0xC1); 
	         I2CSWRead(&cod2);
	         I2CSWStop();
					 if	(
							!I2CSWStart())
					 {	 
                         	I2CSWWrite(0xAA); 
                          	I2CSWWrite(0x1) ;
                          	I2CSWStart()    ;
                          	I2CSWWrite(0xAB);
                          	I2CSWRead(&cod) ;
                         	I2CSWSendACK()  ;
                          	I2CSWRead(&cod2);
                          	I2CSWSendNACK() ;
                         	I2CSWStop()	    ;
       					    log("Init I2C mode  COD1 %d COD2 %d \n",i,(cod&255),(cod2&255));
							if ((cod&255)==0 || (cod&255)==0x86) i=10;
					 }
					 else
					 {
							Sleep(1000);
					 }
			}		 
//		 SetPriorityClass(sd,NORMAL_PRIORITY_CLASS);
//       SetThreadPriority(ss,priii);
                {
                    while (WaitForSingleObject(hBreakEvent, 0) != WAIT_OBJECT_0)
                    {
                      Sleep(key_pause);
                      if	(!I2CSWStart())
					  {
                         I2CSWWrite(0xAA); 
                         I2CSWWrite(0x1) ;
                         I2CSWStart()    ;
                         I2CSWWrite(0xAB);
                         I2CSWRead(&cod) ;
                         I2CSWSendACK()  ;
                         I2CSWRead(&cod2);
                         I2CSWSendNACK() ;
                         I2CSWStop()     ;
 						 cod2=cod2&0xFF;
						 cod=cod&0xFF;
					  }
					  else cod=0;
                         if	(cod==0x86)
                         {			// any key is pressed
							 if (last_code == cod2)
                            {		// auto repeat for any pressed key
                               key_pause = repeat_delay;
                            } 
                            else
                            {		// first run for any pressed key 
                               last_code = cod2;
                               key_pause = first_delay;
                            }
                         }
                        else  // no one key is pressed
                        {	 
                            last_code = 0xFF;
                            key_pause = first_delay;
                        }
                        AddStroke(last_code);                             
//                        log("COD1 %d COD2 %d \n",cod,cod2);
                    }
                log("M205p_VCR: Break event received. Bye!\n");
                FreeLibrary(dllhandle);
                };
        };
};

extern "C"
{
        __declspec(dllexport) IJTVRemoteControl *__stdcall GetInterfacePtr()
        {
                return new JTVRemote(keys, sizeof(keys) / sizeof(keys[0]));
        };
};


